Loading...
Searching...
No Matches
casacore::MDoppler Class Reference
measures package (libcasa_measures) » Measures_module

More...

`#include <MDoppler.h>`

## Public Types

enum | Types { RADIO , Z , RATIO , BETA , GAMMA , N_Types , OPTICAL , RELATIVISTIC , DEFAULT }
| Types of known MDopplers Warning: The order defines the order in the translation matrix FromTo in the getConvert routine; Do not change the order without changing the array; Additions should be made before N_types, and an additional row and column should be coded in FromTo, and in showType(); . More...
typedef MVDoppler | MVType
| Measure value container for this class (i.e.
typedef MCDoppler | MCType
| Measure conversion routines for this class (i.e.
typedef MeasRef< MDoppler > | Ref
| Measure reference (i.e.
typedef MeasConvert< MDoppler > | Convert
| Measure Convert (i.e.
typedef ScalarMeasColumn< MDoppler > | ScalarColumn
| Measure table Columns (e.g., MDoppler::ScalarColumn).
typedef ArrayMeasColumn< MDoppler > | ArrayColumn
Public Types inherited from casacore::Measure
enum | Types { N_Types , DEFAULT }
| Each derived class should have a Types enumeration, specifying the recognised frame types. More...
typedef void * | Convert
| Each Measure should have typedefs of the form:

## Public Member Functions

| MDoppler ()
| Tip: In the following constructors and other functions, all MeasRef can be replaced with simple Measure::TYPE where no offsets or frames are needed in the reference; Default constructor; generates a zero rest Doppler
| MDoppler (const MVDoppler &dt)
| Create from data and reference.
| MDoppler (const MVDoppler &dt, const MDoppler::Ref &rf)
| MDoppler (const MVDoppler &dt, MDoppler::Types rf)
| MDoppler (const Quantity &dt)
| MDoppler (const Quantity &dt, const MDoppler::Ref &rf)
| MDoppler (const Quantity &dt, MDoppler::Types rf)
| MDoppler (const Measure *dt)
| MDoppler (const MeasValue *dt)
virtual | ~MDoppler ()
virtual const String & | tellMe () const
| Tell me your type.
Bool | giveMe (MDoppler::Ref &mr, const String &in)
virtual Bool | setOffset (const Measure &in)
| Set the offset in the reference (False if non-matching Measure).
virtual Bool | setRefString (const String &in)
| Set the reference type to the specified String.
virtual const String & | getDefaultType () const
| Get the default reference type.
virtual const String * | allTypes (Int &nall, Int &nextra, const uInt *&typ) const
| Get a list of all known reference codes.
virtual void | checkTypes () const
| Check if all internal tables of types (both enum and String) are complete and correct.
virtual String | getRefString () const
| Get the reference type (for records, including codes like R_).
Quantity | get (const Unit &un) const
| Get in specified units.
Vector< Double > | shiftFrequency (const Vector< Double > &freq) const
| Shift the input frequencies to the output frequencies.
Quantum< Vector< Double > > | shiftFrequency (const Quantum< Vector< Double > > &freq) const
virtual Measure * | clone () const
| Make a copy.
Public Member Functions inherited from casacore::MeasBase< MVDoppler, MeasRef< MDoppler > >
| MeasBase ()
| Tip: In the following constructors and other functions, all MeasRef can be replaced with simple Measure::TYPE where no offsets or frames are needed in the reference; For reasons of compiler limitations the formal arguments had to be specified as uInt rather than the Measure enums that should be used as actual arguments; Default constructor
MeasBase< MVDoppler, MeasRef< MDoppler > > & | operator= (const MeasBase< MVDoppler, MeasRef< MDoppler > > &other)
| Copy assignment.
virtual | ~MeasBase ()
virtual Bool | areYou (const String &tp) const
| Check the type of derived entity.
virtual void | assured (const String &tp) const
| Assert that we are the correct type.
void | set (const MVDoppler &dt)
| Refill the specified entities.
virtual Bool | putValue (const Vector< Quantum< Double > > &in)
MeasRef< MDoppler > | getRef () const
| Get reference.
const MVDoppler & | getValue () const
| Get Measure data.
const Unit & | getUnit () const
| Get Unit.
virtual MRBase * | getRefPtr () const
| Get reference pointer.
virtual const MeasValue * | getData () const
| Get pointer to data.
virtual void | print (std::ostream &os) const
| Print a Measure.
Public Member Functions inherited from casacore::Measure
virtual | ~Measure ()
| Destructor.
virtual void | set (const MeasValue &dt)=0
| Each Measure should have the following set functions (with appropiate MVs and Ref):
virtual Bool | isModel () const
| Tell me if you are a pure model (e.g.
void | dummy_giveMe () const
| Each derived class should have a string-to-code translation routine for the reference type.
void | dummy_getRef () const
| Each class should have a function to return its reference:
void | dummy_getValue () const
| Each derived class should be able to get its internal value and have:

## Static Public Member Functions

static const String & | showMe ()
static void | assure (const Measure &in)
static MDoppler::Types | castType (uInt tp)
| Translate reference code.
static const String & | showType (MDoppler::Types tp)
static const String & | showType (uInt tp)
static Bool | getType (MDoppler::Types &tp, const String &in)
| Translate string to reference code.
static const String * | allMyTypes (Int &nall, Int &nextra, const uInt *&typ)
static void | checkMyTypes ()
Static Public Member Functions inherited from casacore::Measure
static uInt | giveMe (const String &in, Int N_name, const String tname[])
| A general string checking routine to be used in derived measures.

## Friends

class | MeasConvert< MDoppler >
| Conversion of data.

## Additional Inherited Members

Protected Attributes inherited from casacore::MeasBase< MVDoppler, MeasRef< MDoppler > >
MVDoppler | data
| The measure value (e.g.
MeasRef< MDoppler > | ref
| Reference frame data.
Unit | unit
| Possible input units.

## Detailed Description

A Measure: Doppler shift

### Intended use:

Public interface

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25
Test programs:
  tMeasure

### Prerequisite

- Measure class

### Etymology

From Measure and Doppler

### Synopsis

MDoppler forms the derived Measure class for Doppler shifts.
An MDoppler can be generated from a simple value (or an MVDoppler), which is then interpreted as a Doppler ratio, and a reference, with a RADIO type as default.
It can also be generated from a Quantity, where the interpretation depends on the dimensionality of the Quantity:

- None: a Doppler ratio
- Velocity: Doppler ratio calculated by dividing with c

The different types of Doppler (with F = f/f0, the frequency ratio), are:

- MDoppler::Z (-1 + 1/F)
- MDoppler::RATIO (F) *
- MDoppler::RADIO (1 - F)
- MDoppler::OPTICAL == Z
- MDoppler::BETA ((1 - F2)/(1 + F2))
- MDoppler::GAMMA ((1 + F2)/2F) *
- MDoppler::RELATIVISTIC == BETA (== v/c)
- MDoppler::DEFAULT == RADIO

Note that the ones with an '*' have no real interpretation (although the calculation will proceed) if given as a velocity.

Conversion between the different types is done with the standard MeasConvert class (MDoppler::Convert in this case).

Dopplers can be created from an MFrequency object, or from an MRadialVelocity object.

A shiftFrequency() method can shift frequencies.

Dopplers do not need a reference frame.

### Example

Conversion of a radio Doppler to an optical

MDoppler radio(0.01); // A radio Doppler value
cout << "Doppler radio = " << radio << "; optical = " <<
MDoppler::Convert(radio, MDoppler::OPTICAL)() << // Convert
endl;
casacore::MDoppler::MDoppler
MDoppler()
Tip: In the following constructors and other functions, all MeasRef can be replaced with simple Measu...
casacore::MDoppler::Convert
MeasConvert< MDoppler > Convert
Measure Convert (i.e.
Definition MDoppler.h:165
casacore::MDoppler::OPTICAL
@ OPTICAL
Definition MDoppler.h:153

Setting up a conversion

MDoppler::Convert to_opt(MDoppler::RADIO, MDoppler::OPTICAL);
for (Double d=0; d<0.1; d += 0.005) {
cout << "radio = " << d << " to optical = " <<
to_opt(d) << endl;
casacore::MDoppler::RADIO
@ RADIO
Definition MDoppler.h:147
casacore::Double
double Double
Definition aipstype.h:53

### Motivation

### To Do

Definition at line 131 of file MDoppler.h.

## Member Typedef Documentation

## ArrayColumn

typedef ArrayMeasColumn<MDoppler> casacore::MDoppler::ArrayColumn

Definition at line 168 of file MDoppler.h.

## Convert

typedef MeasConvert<MDoppler> casacore::MDoppler::Convert

Measure Convert (i.e.

MDoppler::Convert)

Definition at line 165 of file MDoppler.h.

## MCType

typedef MCDoppler casacore::MDoppler::MCType

Measure conversion routines for this class (i.e.

MDoppler::MCType)

Definition at line 161 of file MDoppler.h.

## MVType

typedef MVDoppler casacore::MDoppler::MVType

Measure value container for this class (i.e.

MDoppler::MVType)

Definition at line 159 of file MDoppler.h.

## Ref

typedef MeasRef<MDoppler> casacore::MDoppler::Ref

Measure reference (i.e.

MDoppler::Ref)

Definition at line 163 of file MDoppler.h.

## ScalarColumn

typedef ScalarMeasColumn<MDoppler> casacore::MDoppler::ScalarColumn

Measure table Columns (e.g., MDoppler::ScalarColumn).

Definition at line 167 of file MDoppler.h.

## Member Enumeration Documentation

## Types

enum casacore::MDoppler::Types

Types of known MDopplers
Warning: The order defines the order in the translation matrix FromTo in the getConvert routine; Do not change the order without changing the array; Additions should be made before N_types, and an additional row and column should be coded in FromTo, and in showType();
.

Enumerator
RADIO |
Z |
RATIO |
BETA |
GAMMA |
N_Types |
OPTICAL |
RELATIVISTIC |
DEFAULT |

Definition at line 146 of file MDoppler.h.

## Constructor & Destructor Documentation

## MDoppler() [1/9]

casacore::MDoppler::MDoppler | ( |  | ) |

Tip: In the following constructors and other functions, all MeasRef can be replaced with simple Measure::TYPE where no offsets or frames are needed in the reference;
Default constructor; generates a zero rest Doppler

Referenced by MeasConvert< MDoppler >.

## MDoppler() [2/9]

casacore::MDoppler::MDoppler | ( | const MVDoppler & | dt | ) |

Create from data and reference.

## MDoppler() [3/9]

casacore::MDoppler::MDoppler | ( | const MVDoppler & | dt,
|  | const MDoppler::Ref & | rf )

## MDoppler() [4/9]

casacore::MDoppler::MDoppler | ( | const MVDoppler & | dt,
|  | MDoppler::Types | rf )

## MDoppler() [5/9]

casacore::MDoppler::MDoppler | ( | const Quantity & | dt | ) |

## MDoppler() [6/9]

casacore::MDoppler::MDoppler | ( | const Quantity & | dt,
|  | const MDoppler::Ref & | rf )

## MDoppler() [7/9]

casacore::MDoppler::MDoppler | ( | const Quantity & | dt,
|  | MDoppler::Types | rf )

## MDoppler() [8/9]

casacore::MDoppler::MDoppler | ( | const Measure * | dt | ) |

## MDoppler() [9/9]

casacore::MDoppler::MDoppler | ( | const MeasValue * | dt | ) |

## ~MDoppler()

virtual casacore::MDoppler::~MDoppler | ( |  | ) |

virtual

## Member Function Documentation

## allMyTypes()

const String * casacore::MDoppler::allMyTypes | ( | Int & | nall,
|  | Int & | nextra,
|  | const uInt *& | typ )

static

## allTypes()

virtual const String * casacore::MDoppler::allTypes | ( | Int & | nall,
|  | Int & | nextra,
|  | const uInt *& | typ ) const

virtual

Get a list of all known reference codes.

nall returns the number in list, nextra the number of specials (like planets) that should be at end of list). typ returns the list of corresponding types.

Reimplemented from casacore::Measure.

## assure()

void casacore::MDoppler::assure | ( | const Measure & | in | ) |

static

## castType()

MDoppler::Types casacore::MDoppler::castType | ( | uInt | tp | ) |

static

Translate reference code.

The uInt version has a check for valid codes (i.e. it is a safe cast).

### Thrown Exceptions

- AipsError in the uInt interface if illegal code given

## checkMyTypes()

void casacore::MDoppler::checkMyTypes | ( |  | ) |

static

## checkTypes()

virtual void casacore::MDoppler::checkTypes | ( |  | ) | const

virtual

Check if all internal tables of types (both enum and String) are complete and correct.

This function is called automatically if and when necessary.

### Thrown Exceptions

- AipsError if a (programming) error in the types.

Implements casacore::Measure.

## clone()

virtual Measure * casacore::MDoppler::clone | ( |  | ) | const

virtual

Make a copy.

Implements casacore::Measure.

## get()

Quantity casacore::MDoppler::get | ( | const Unit & | un | ) | const

Get in specified units.

## getDefaultType()

virtual const String & casacore::MDoppler::getDefaultType | ( |  | ) | const

virtual

Get the default reference type.

Implements casacore::Measure.

## getRefString()

virtual String casacore::MDoppler::getRefString | ( |  | ) | const

virtual

Get the reference type (for records, including codes like R_).

Implements casacore::Measure.

## getType()

Bool casacore::MDoppler::getType | ( | MDoppler::Types & | tp,
|  | const String & | in )

static

Translate string to reference code.

## giveMe()

Bool casacore::MDoppler::giveMe | ( | MDoppler::Ref & | mr,
|  | const String & | in )

## setOffset()

virtual Bool casacore::MDoppler::setOffset | ( | const Measure & | in | ) |

virtual

Set the offset in the reference (False if non-matching Measure).

Implements casacore::Measure.

## setRefString()

virtual Bool casacore::MDoppler::setRefString | ( | const String & | in | ) |

virtual

Set the reference type to the specified String.

False if illegal string, reference set to DEFAULT.

Implements casacore::Measure.

## shiftFrequency() [1/2]

Quantum< Vector< Double > > casacore::MDoppler::shiftFrequency | ( | const Quantum< Vector< Double > > & | freq | ) | const

## shiftFrequency() [2/2]

Vector< Double > casacore::MDoppler::shiftFrequency | ( | const Vector< Double > & | freq | ) | const

Shift the input frequencies to the output frequencies.

In the case of simple Double inputs, it is assumed that the values are linearly dependent on frequency. I.e. frequencies given as wavelength or time cannot be used.

## showMe()

const String & casacore::MDoppler::showMe | ( |  | ) |

static

## showType() [1/2]

const String & casacore::MDoppler::showType | ( | MDoppler::Types | tp | ) |

static

## showType() [2/2]

const String & casacore::MDoppler::showType | ( | uInt | tp | ) |

static

## tellMe()

virtual const String & casacore::MDoppler::tellMe | ( |  | ) | const

virtual

Tell me your type.

Implements casacore::Measure.

## Friends And Related Symbol Documentation

## MeasConvert< MDoppler >

friend class MeasConvert< MDoppler >

friend

Conversion of data.

Definition at line 1 of file MDoppler.h.

References MDoppler().

The documentation for this class was generated from the following file:

- measures/Measures/MDoppler.h